Package org.spongepowered.asm.mixin.struct

## Class SourceMap

- java.lang.Object
- - org.spongepowered.asm.mixin.struct.SourceMap

-     public class SourceMap
      extends java.lang.Object

  Structure which contains information about a SourceDebugExtension SMAP

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `SourceMap.File` | Defines a source code file within a source map stratum

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `SourceMap​(java.lang.String sourceFile)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `SourceMap.File` | `addFile​(java.lang.String sourceFileName, java.lang.String sourceFilePath, int size)` | Add a file to this SourceMap in the default stratum
    `SourceMap.File` | `addFile​(java.lang.String stratumName, java.lang.String sourceFileName, java.lang.String sourceFilePath, int size)` | Add a file to this SourceMap in the specified stratum
    `SourceMap.File` | `addFile​(java.lang.String stratumName, org.objectweb.asm.tree.ClassNode classNode)` | Add a file to this SourceMap in the specified stratum
    `SourceMap.File` | `addFile​(org.objectweb.asm.tree.ClassNode classNode)` | Add a file to this SourceMap in the default stratum
    `java.lang.String` | `getPseudoGeneratedSourceFile()` | Get the generated source file
    `java.lang.String` | `getSourceFile()` | Get the original source file
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SourceMap

          public SourceMap​(java.lang.String sourceFile)

  - ### Method Detail

    - #### getSourceFile

          public java.lang.String getSourceFile()

      Get the original source file

    - #### getPseudoGeneratedSourceFile

          public java.lang.String getPseudoGeneratedSourceFile()

      Get the generated source file

    - #### addFile

          public SourceMap.File addFile​(org.objectweb.asm.tree.ClassNode classNode)

      Add a file to this SourceMap in the default stratum
      Parameters:
        `classNode` - class node to read details from
      Returns:
        new File

    - #### addFile

          public SourceMap.File addFile​(java.lang.String stratumName,
                                        org.objectweb.asm.tree.ClassNode classNode)

      Add a file to this SourceMap in the specified stratum
      Parameters:
        `stratumName` - name of the stratum to add to
        `classNode` - class node to read file details from
      Returns:
        new File

    - #### addFile

          public SourceMap.File addFile​(java.lang.String sourceFileName,
                                        java.lang.String sourceFilePath,
                                        int size)

      Add a file to this SourceMap in the default stratum
      Parameters:
        `sourceFileName` - source filename
        `sourceFilePath` - path to source file
        `size` - number of lines to allocate
      Returns:
        new File

    - #### addFile

          public SourceMap.File addFile​(java.lang.String stratumName,
                                        java.lang.String sourceFileName,
                                        java.lang.String sourceFilePath,
                                        int size)

      Add a file to this SourceMap in the specified stratum
      Parameters:
        `stratumName` - name of the stratum to add to
        `sourceFileName` - source filename
        `sourceFilePath` - path to source file
        `size` - number of lines to allocate
      Returns:
        new File

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`